
<template>
  <div style="margin-top: 20px">
    <v-container class="fill-height">
      <v-row align="center" justify="center">
        <v-col cols="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">search</v-icon>ค้นหา
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-card-text>
              <FilterApplicants
                :status.sync="obj.status"
                :firstName.sync="obj.firstName"
                :lastName.sync="obj.lastName"
              />
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="orange"
                dark
                depressed
                @click="fetchApplicants('reset')"
              >
                <v-icon left> search </v-icon>
                ค้นหา
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col cols="12" md="12" xl="12" sm="12">
          <v-card>
            <!-- Title -->
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">people</v-icon>
                รายการลงทะเบียน
              </v-toolbar-title>
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
            </v-toolbar>
            <br />
            <v-card-text>
              <!-- Loading Data -->
              <Loading
                v-if="loading"
                :propLoading="loading"
                propText="กรุณารอสักครู่"
              />
              <!-- Table -->
              <TableApplicants
                :items="items"
                :loading="loading"
                v-show="!loading"
                @update-table-parent="updateParentData"
              />
              <br />
              <div class="text-center my-1" v-if="items.length > 0">
                <v-pagination
                  v-model="page"
                  :length="length"
                  :total-visible="7"
                  circle
                  @input="handlePageChange"
                  v-show="!loading"
                >
                </v-pagination>
              </div>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import FilterApplicants from "../../../components/accounts/FilterApplicants";
import TableApplicants from "../../../components/accounts/TableApplicants";
import Loading from "../../../components/loading/Loading";
import { AccountModel } from "./model/account";
export default {
  components: {
    FilterApplicants,
    TableApplicants,
    Loading,
  },
  data() {
    return {
      obj: {},
      page: 1,
      items: [],
      length: null,
      loading: true,
    };
  },
  async created() {
    await this.fetchApplicants();
    
  },
  methods: {
    async handlePageChange(value) {
      this.page = value;
      await this.fetchApplicants();
    },
    updateParentData(i) {
      if (i) this.fetchApplicants();
    },
    async fetchApplicants(text) {
      let param = AccountModel.accountParam(text, this.obj, this.page);
      this.page = param.Page;
      await this.$store.dispatch("auth/listAccount", param);
      let res = this.$store.getters["auth/result"];
      let loading = this.$store.getters["auth/loading"];
      this.items = res.content;
      this.length = res.length;
      this.loading = loading;
    },
  },
};
</script>

<style>
</style>